program apcb2htm;

uses crt,dos;

var
  year,month,day,dow : word;
  ftime_dir, ftime_dat : LongInt;
  afac,afac2,daystr,monthstr,yearstr,dateweb : string;
  fichier_dat,fichier_dir,fichier_html,
  fichier_header,fichier_err : text;
  dat_dirpath,
  dat_title,
  dat_background,
  dat_html,
  dat_ftp,
  dat_textlink,
  dat_weblink : string;
  dat_width,dat_header : byte;
  webcolors,
  fichier_name,
  fichier_size,
  fichier_date,
  fichier_desc,
  fichier_descout,
  http, upper, lower, force : string;
  i,end_desc,http_posbegin,http_posend,upper_lower : byte;

Procedure UpCaseStr(Var s : String);
Var
  i : Integer;
Begin
  For i := 1 to Length(s) Do
    s[i] := UpCase(s[i]);
end;

Procedure LowCaseStr(Var s : String);
Var i, len : Integer;
Begin
  i := 0;
  len := Ord(s[0]);
  Repeat
    Inc(i);
    If i > len Then
      Break;
    If s[i] in ['A'..'Z'] Then
      inc(s[i], 32);
   Until False;
end;

FUNCTION Exist(sExp: STRING): BOOLEAN;
VAR s : SearchRec;
BEGIN
  FINDFIRST(sExp,AnyFile,s);
  Exist:=(DOSError=0);
END;

PROCEDURE touch(fichier : string);

Var F : Text;
    H,M,S,Hund : Word;
    DOW,Year,Month,Day : Word;
    FTime : LongInt;
    DT : DateTime;

Begin
  Assign(F,fichier);
  reset(f);
  GetTime(H,M,S,Hund);
  GetDate(Year,Month,Day,DOW);
  DT.Hour:=H;
  DT.Min:=M;
  DT.Sec:=S;
  DT.Year:=Year;
  DT.Month:=Month;
  DT.Day:=Day;
  PackTime(DT,FTime);
  SetFTime(F,FTime);
  close(f);
End;


BEGIN
  clrscr;
  writeln('APCB2HTM v1.08 (18th January 2003)');
  writeln('(c) Emmanuel Roussin');
  writeln('Web     http://genesis8.free.fr/apcb2htm');
  writeln('Email   roussin@noos.fr');
  writeln('Fidonet 2:320/200');
  writeln;
  writeln('if you are using this program, let me know by email or netmail, thanks.');
  writeln;
  getdate(year, month, day, dow);
  str(year,yearstr);
  str(month,monthstr);
  str(day,daystr);
  IF length(monthstr)=1 THEN
    monthstr:='0'+monthstr;
  IF length(daystr)=1 THEN
    daystr:='0'+daystr;
  dateweb:=yearstr+monthstr+daystr;

  {managing command line parameter}

  IF paramstr(1)='' THEN
  BEGIN
    writeln('no parameter on command line, need a DAT file');
    assign(fichier_err,'error.txt');
    append(fichier_err);
    writeln(fichier_err,dateweb,' - no parameter on command line for APCB2HTM');
    close(fichier_err);
    halt;
  END;

  {managing DAT file given on command line}

  IF exist(paramstr(1)) THEN
  BEGIN
    assign(fichier_dat,paramstr(1));
    reset(fichier_dat);
    getftime(fichier_dat,ftime_dat);
  END
  ELSE
  BEGIN
    writeln(paramstr(1),' doesnt exist, check your command line');
    assign(fichier_err,'error.txt');
    append(fichier_err);
    writeln(fichier_err,dateweb,' - ',paramstr(1),' doesnt exist, check your command line');
    close(fichier_err);
    halt;
  END;
  readln(fichier_dat,dat_dirpath);
  readln(fichier_dat,dat_title);
  readln(fichier_dat,dat_background);
  readln(fichier_dat,dat_width);
  readln(fichier_dat,dat_html);
  readln(fichier_dat,dat_ftp);
  readln(fichier_dat,dat_textlink);
  readln(fichier_dat,dat_weblink);
  readln(fichier_dat,dat_header);
  close(fichier_dat);

  {opening PCBoard DIR file}

  IF exist(dat_dirpath) THEN
  BEGIN
    assign(fichier_dir,dat_dirpath);
    reset(fichier_dir);
    getftime(fichier_dir,ftime_dir);
  END
  ELSE
  BEGIN
    writeln(dat_dirpath,' stated in ',paramstr(1),' doesnt exist');
    assign(fichier_err,'error.txt');
    append(fichier_err);
    writeln(fichier_err,dateweb,' - ',dat_dirpath,' stated in ',paramstr(1),' doesnt exist');
    close(fichier_err);
    halt;
  END;

  {by default APCB2HTM like PCB2HTM always create a HTML file, but if
  you put 'noforce' as the 2nd parameter on command line, a date/time
  check will be done on the DAT file (touched at the end of program) and
  the PCBoard DIR file, the HTML file will only be created if DIR is
  newer than the DAT}

  force:=paramstr(2);
  lowcasestr(force);
  IF force='noforce' THEN
    IF (ftime_dat > ftime_dir) OR (ftime_dat = ftime_dir) THEN
    BEGIN
      writeln('No update on ',dat_dirpath,', I dont create a HTML page');
      close(fichier_dir);
      halt;
    END;

  {managing header.dat file}

  IF exist('header.dat') THEN
  BEGIN
    assign(fichier_header,'header.dat');
    reset(fichier_header);
  END
  ELSE
  BEGIN
    writeln('HEADER.DAT doesnt exist, get it from APCB2HTM.ZIP');
    close(fichier_dir);
    assign(fichier_err,'error.txt');
    append(fichier_err);
    writeln(fichier_err,dateweb,' - HEADER.DAT doesnt exist, get it from APCB2HTM.ZIP');
    close(fichier_err);
    halt;
  END;

  {start to write HTML file}

  assign(fichier_html,dat_html);
  rewrite(fichier_html);
  writeln(fichier_html,'<HTML>');
  writeln(fichier_html,'<HEAD>');
  writeln(fichier_html,'<TITLE>',dat_title,'</TITLE>');

  readln(fichier_header,upper_lower);
  readln(fichier_header,webcolors);
  while not eof(fichier_header) DO
  BEGIN
    readln(fichier_header,afac);
    writeln(fichier_html,afac);
  END;
  close(fichier_header);
  writeln(fichier_html,'<META NAME="Date-Revision-',dateweb,'" CONTENT="',dateweb,'">');
  writeln(fichier_html,'</HEAD>');
  IF dat_background<>'NOBACK'THEN
    insert(dat_background,webcolors,length(webcolors)-1);
  writeln(fichier_html,webcolors);
  writeln(fichier_html,'<PRE>');
  writeln(fichier_html,'<TABLE BORDER=2 CELLPADDING=10>');
  writeln(fichier_html,'<TR><TD COLSPAN=4><CENTER>',dat_title,'<BR>');
  writeln(fichier_html,'last update on ',daystr,'/',monthstr,'/',year:0,'</CENTER></TD></TR>');
  writeln(fichier_html,'<TR><TD>Name</TD><TD>Size</TD><TD>Date</TD><TD>Description');

  {skipping useless lines at the start of the DIR file}

  FOR i:=1 to dat_header DO
  BEGIN
    readln(fichier_dir,afac);
  END;

  {begin conversion of DIR to HTML}

  while not eof(fichier_dir) DO
  BEGIN
    readln(fichier_dir,afac);
    fichier_name:=copy(afac,1,pos(' ',afac)-1);
    fichier_size:=copy(afac,14,8);
    fichier_date:=copy(afac,24,8);
    fichier_desc:='X'+copy(afac,34,length(afac)-33)+'X';
    fichier_descout:='';
    end_desc:=length(fichier_desc);
    FOR i:=2 to (end_desc-1) DO
    BEGIN
      CASE fichier_desc[i] OF

      {translation of french/german accentued characters}

      '' : fichier_descout:=fichier_descout+'';
      '' : fichier_descout:=fichier_descout+'';
      '' : fichier_descout:=fichier_descout+'';
      '' : fichier_descout:=fichier_descout+'';
      '' : fichier_descout:=fichier_descout+'';
      '' : fichier_descout:=fichier_descout+'';
      '' : fichier_descout:=fichier_descout+'';
      '' : fichier_descout:=fichier_descout+'';
      '' : fichier_descout:=fichier_descout+'';
      '' : fichier_descout:=fichier_descout+'';
      '' : fichier_descout:=fichier_descout+'';

      {translation of other characters}

      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'|';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'-';
      '' : fichier_descout:=fichier_descout+'|';

      {translation of multiple spaces to &nbsp}

      ' ' : IF fichier_desc[i-1]=' ' THEN
              fichier_descout:=fichier_descout+'&nbsp'
            ELSE
              fichier_descout:=fichier_descout+' ';

      {HTML dont like <>}

      '<' : fichier_descout:=fichier_descout+'(';
      '>' : fichier_descout:=fichier_descout+')';
      ELSE
      fichier_descout:=fichier_descout+fichier_desc[i];
      END;
    END;

    {now looking for a http address to transform into a valid web link}

    http_posbegin:=pos('http://',fichier_descout);
    IF http_posbegin>0 THEN
    BEGIN
      afac2:=copy(fichier_descout,http_posbegin,length(afac)-http_posbegin);
      http_posend:=pos(' ',afac2);
      IF http_posend=0 THEN
        http_posend:=length(afac2)+1;
      {removing / if it's the last character, it's useless}
      IF fichier_descout[http_posend-1]='/' THEN
        http:=copy(afac2,1,http_posend-2)
      ELSE
        http:=copy(afac2,1,http_posend-1);
      afac2:=concat('<A HREF="',http,'"TARGET="_blank">');
      insert('</A>',fichier_descout,http_posend+http_posbegin-1);
      insert(afac2,fichier_descout,http_posbegin);
    END;

    {now we write the description line to HTML file}

    IF afac[1]=' ' THEN
      IF fichier_desc='XX' THEN
        writeln(fichier_html,'<BR>')
      ELSE
        writeln(fichier_html,fichier_descout,'<BR>')
    ELSE
      BEGIN
        writeln(fichier_html,'</TD></TR>');
        lower:=fichier_name;
        lowcasestr(lower);
        IF upper_lower=0 THEN
          BEGIN
            write(fichier_html,'<TR><TD><A HREF="',dat_ftp,lower,'">',lower,'</A>');
          END
        ELSE
          BEGIN
            upper:=fichier_name;
            upcasestr(upper);
            write(fichier_html,'<TR><TD><A HREF="',dat_ftp,upper,'">',lower,'</A>');
          END;
        writeln(fichier_html,'</TD><TD>',fichier_size,'</TD><TD>',fichier_date,'</TD><TD>',fichier_descout,'<BR>');
      END;
  END;
  close(fichier_dir);
  writeln(fichier_html,'</TD></TR>');
  writeln(fichier_html,'</TABLE><P>');
  writeln(fichier_html,'Go back to <A HREF="',dat_weblink,'">',dat_textlink,'</A><P>');
  writeln(fichier_html,'HTML page created by <A HREF="http://genesis8.free.fr/apcb2htm"TARGET="_blank">APCB2HTM v1.08</A>');
  writeln(fichier_html,'</PRE></BODY>');
  writeln(fichier_html,'</HTML>');
  close(fichier_html);
  touch(paramstr(1));
END.
